<template>
  <ui-form
    :News="News"
    :editMode="editMode"
    :titreLabels="titreLabels"
    :ouiLabels="ouiLabels"
    :ouiValues="ouiValues"
    :descriptionLabels="descriptionLabels"
    :switchLabels="switchLabels"
    :listeLabels="listeLabels"
    :contentListes="contentListes"
    :totalTitres="totalTitres"
    :totalDescriptions="totalDescriptions"
    :totalSwitchs="totalSwitchs"
    :totalOuis="totalOuis"
    :totalListes="totalListes"
    :declinaisonsLabels="declinaisonsLabels"
    :totalImages="totalImages"
    :totalPdfs="totalPdfs"
    :totalVideos="totalVideos"
    :listeLibelleImages="listeLibelleImages"
    :listeLibellePdfs="listeLibellePdfs"
    :listeLibelleVideos="listeLibelleVideos"
    :moduleName="moduleName"
    :action="action"
    v-on:returnValuesForm="actionSubmit($event)"
    v-on:refreshCat="reRenderComponent()"
    v-on:returnDelete="actionDelete()"
    ref="secondLevel"
  ></ui-form>
</template>

<script>
// import axios from "axios";
import uiForm from "./_form.vue";
import jsonConfigBuilder from "@/config-data/config-products.json";

const URL_API = process.env.VUE_APP_URL_DISTANT_API;
var URL_NEWS;
var URL_NEWS_EDIT;
var URL_DELETE_ENTRY;

export default {
  props: ["moduleName", "action"],
  // mounted: function() {
  beforeMount: function () {
    this.jsonConfigBuilder.forEach((mod) => {
      if (mod.module === this.moduleName) {
        this.tableName = mod.tableName;
        this.moduleJson = mod;
      }
    });

    this.loadUrls();
    // console.log("this.tableName", this.tableName);
    // utilisation du beforeMount car dans le children les props etaient vides sinon
    // recuperation des ressources dont nous avons besoin
    this.getInputLabel();
    this.getLabelDeclinaisons();
    this.loadDataProperties();
    this.loadMediasConfig();
  },
  components: {
    "ui-form": uiForm,
  },
  data() {
    return {
      tableName: null,

      //initialisation des parametres envoyé au formulaire
      // todo changer le nom News de la variable dessous
      News: {
        name: this.moduleName,
        actif: true,
        ordre: 0,
        data: {},
      },
      dataPayload: {},
      jsonConfigBuilder,
      moduleJson: {},
      declinaisonsLabels: [],
      prixLabels: [],
      editMode: false,
      titreLabels: [],
      ouiLabels: [],
      ouiValues: [],
      descriptionLabels: [],
      switchLabels: [],
      listeLabels: [],
      contentListes: [],
      totalTitres: 0,
      totalDescriptions: 0,
      totalSwitchs: 0,
      totalOuis: 0,
      totalListes: 0,
      totalImages: 0,
      totalPdfs: 0,
      listeLibelleImages: [],
      listeLibellePdfs: [],
      listeLibelleVideos: [],
      // listeMultipleLabels: [],
    };
  },
  methods: {
    loadUrls() {
      URL_NEWS = URL_API + "api/" + this.tableName + "/create";
      URL_NEWS_EDIT = URL_API + "api/" + this.tableName + "/edit/";
      URL_DELETE_ENTRY = URL_API + "api/" + this.tableName + "/delete/";
    },
    firstlevelCall() {
      // fonction appelé d'un parent
    },
    getInputLabel() {
      // Construction des entêtes des tableaux

      this.moduleJson.config.forEach((el) => {
        switch (el.type) {
          case "titre":
            this.titreLabels.push(el.libelle);
            this.totalTitres++;
            break;
          case "oui":
            this.ouiLabels.push(el.libelle);
            this.ouiValues.push(el.value);
            this.totalOuis++;
            break;
          case "description":
            this.descriptionLabels.push(el.libelle);
            this.totalDescriptions++;
            break;
          case "switch":
            this.switchLabels.push(el.libelle);
            this.totalSwitchs++;
            break;
          case "liste":
            this.listeLabels.push(el.libelle);
            this.contentListes.push(el.items);
            this.totalListes++;
            break;
        }
      });
    },
    getLabelDeclinaisons() {
      if (this.moduleJson.declinaisons) {
        this.moduleJson.declinaisons.forEach((el) => {
          this.declinaisonsLabels.push(el);
        });
      }
      if (this.moduleJson.prix) {
        this.moduleJson.prix.forEach((el) => {
          this.prixLabels.push(el.libelle);
        });
      }
    },
    loadMediasConfig() {
      //on charge les infos du jsonConfig pour hydrater l'objet News.data
      if (this.moduleJson.medias.images !== null) {
        this.totalImages = this.moduleJson.medias.images;
      }
      if (this.moduleJson.medias.libellesImages) {
        this.moduleJson.medias.libellesImages.forEach((el) => {
          this.listeLibelleImages.push(el);
        });
      }

      if (this.moduleJson.medias.pdfs !== null) {
        this.totalPdfs = this.moduleJson.medias.pdfs;
      }

      if (this.moduleJson.medias.libellesPdf) {
        this.moduleJson.medias.libellesPdf.forEach((el) => {
          this.listeLibellePdfs.push(el);
        });
      }

      if (this.moduleJson.medias.videos !== null) {
        this.totalVideos = this.moduleJson.medias.videos;
      }

      if (this.moduleJson.medias.libellesVideos) {
        this.moduleJson.medias.libellesVideos.forEach((el) => {
          this.listeLibelleVideos.push(el);
        });
      }

      // console.log("moduleJson.medias", this.moduleJson.medias);
      // console.log("listeLibelleVideos", this.listeLibelleVideos);
      // console.log("totalVideos", this.totalVideos);
    },
    loadDataProperties() {
      //on charge les infos du jsonConfig pour hydrater l'objet News.data
      this.moduleJson.config.forEach((el) => {
        this.News.data[el.champs] = el.default;
      });
    },
    reRenderComponent() {
      // on emet une valeur pour forcer le rendu du component parent
      this.$emit("refreshFromComponent", true);
    },
    actionDelete() {
      let id = this.$route.params.id;
      this.$axios
        .delete(URL_DELETE_ENTRY + id)
        .then((response) => {
          this.$router.push({ name: "admin-gestion-produits-liste", params: { module: this.moduleName } });
        })
        .catch((error) => {
          console.log("error = ", error);
        });
    },
    actionSubmit(infoForm) {
      // récupération des valeurs du formulaire (a controller ensuite)
      let payload = {
        name: this.moduleName,
        actif: infoForm.activeField,
        ordre: infoForm.ordreField,
        data: infoForm.globalFields,
        dataprix: infoForm.priceFields,
      };

      console.log("PL =", payload);

      // on enregistre dans l'API distante les nouvelles données

      // COMMENT FOR DEBUG
      let debug = false;

      if (debug === false) {
        if (this.action == "edit") {
          let id = this.$route.params.id;
          this.$axios
            .put(URL_NEWS_EDIT + id, payload)
            .then((response) => {
              this.$router.push({ name: "admin-gestion-produits-liste", params: { module: this.moduleName } });
            })
            .catch((error) => {
              console.log("error = ", error);
            });
        } else {
          this.$axios
            .post(URL_NEWS, payload)
            .then((response) => {
              this.$router.push({ name: "admin-gestion-produits-liste", params: { module: this.moduleName } });
            })
            .catch((error) => {
              console.log("error = ", error);
            });
        }
      }
    },
  },
};
</script>
